

CREATE TABLE USERS(
	U_ID NUMBER(3) PRIMARY KEY,
	NAME VARCHAR2(25) NOT NULL,
	EMAIL VARCHAR2(40) NOT NULL,
	USER_NAME VARCHAR2(25),
	PASSWORD VARCHAR2(25),
	STATUS VARCHAR2(5) CHECK (STATUS ='EMP' OR STATUS ='CUST' OR STATUS = 'MGMT')
);


CREATE TABLE ACCOUNT(
	ACCOUNT_ID NUMBER(3) PRIMARY KEY,
	U_ID NUMBER(3) REFERENCES USERS,
	BALANCE NUMBER(10,2) NOT NULL
);

CREATE TABLE WAITING_APPROVAL(
	ACCOUNT_ID NUMBER(3)PRIMARY KEY,
	U_ID NUMBER(3) REFERENCES USERS,
	START_BAL NUMBER(10,2)
);

CREATE TABLE TRANSACTIONS(
	TRANSACTION_ID NUMBER(10) PRIMARY KEY,
	USER_ID NUMBER(3) REFERENCES USERS,
	ACCOUNT_ID NUMBER(3) REFERENCES ACCOUNT,
	NEW_BALANCE NUMBER(10,2)
	
);

CREATE SEQUENCE USER_ID_SEQ
MINVALUE 1
START WITH 1
INCREMENT BY 1
CACHE 5;

CREATE SEQUENCE ACCOUNT_ID_SEQ
MINVALUE 1
START WITH 4
INCREMENT BY 1
CACHE 5;

CREATE SEQUENCE TRANSACTION_ID_SEQ
MINVALUE 1
START WITH 1
INCREMENT BY 1
CACHE 5;

CREATE OR REPLACE TRIGGER USER_ID_TRIG
BEFORE INSERT ON USERS 
FOR EACH ROW
BEGIN 
	SELECT USER_ID_SEQ.NEXTVAL INTO :NEW.U_ID FROM DUAL;
END;


CREATE OR REPLACE TRIGGER ACCOUNT_ID_TRIG
BEFORE INSERT ON WAITING_APPROVAL 
FOR EACH ROW
BEGIN 
	SELECT ACCOUNT_ID_SEQ.NEXTVAL INTO :NEW.ACCOUNT_ID FROM DUAL;
END;

CREATE OR REPLACE TRIGGER TRANSACTION_ID_TRIG
BEFORE INSERT ON TRANSACTIONS 
FOR EACH ROW
BEGIN 
	SELECT TRANSACTION_ID_SEQ.NEXTVAL INTO :NEW.TRANSACTION_ID FROM DUAL;
END;




--SELECT* FROM USER_ERRORS WHERE TYPE = 'TRIGGER' AND NAME = 'USER_ID_TRIG'

--insert managers
INSERT INTO USERS(NAME,EMAIL,USER_NAME,PASSWORD,STATUS)
VALUES ('don draper', 'alcholoic@draperprice.com','MadMan', 'Creative','MGMT');

--insert employees
INSERT INTO USERS (NAME ,EMAIL,USER_NAME ,PASSWORD ,STATUS )
VALUES ('ben kenobi', 'oldben@moseisley', 'ObiWan', 'H3ll0There','EMP');

INSERT INTO USERS (NAME ,EMAIL,USER_NAME ,PASSWORD ,STATUS )
VALUES ('johnny silverhand', 'chippingin@arasaka.net', 'Silverhand', 'NeverFadeAway','EMP');

INSERT INTO USERS (NAME ,EMAIL,USER_NAME ,PASSWORD ,STATUS )
VALUES ('paul atreides', 'waterful@dune.org', 'MuadDib', 'Paul1','EMP');

INSERT INTO USERS (NAME ,EMAIL,USER_NAME ,PASSWORD ,STATUS )
VALUES ('Grace Kellie', 'kc@princess.com','Honey','Evergreen','EMP');

--insert customers
INSERT INTO USERS (NAME,EMAIL ,USER_NAME ,PASSWORD ,STATUS)
VALUES ('donald glover','dglove@3005.net','Gambino','CommunityLover2','CUST');

INSERT INTO USERS (NAME,EMAIL ,USER_NAME ,PASSWORD ,STATUS)
VALUES ('kratos','mydadsemail@mimir.org','GodOfWar','MyDadsPassword','CUST');

INSERT INTO USERS (NAME,EMAIL ,USER_NAME ,PASSWORD ,STATUS)
VALUES ( 'thomas anderson','choseone@matrix.net','Chosen0ne','WhiteRabbit','CUST');

INSERT INTO USERS(NAME,EMAIL,USER_NAME,PASSWORD,STATUS)
VALUES('wanda maximoff', 'toomanyfakeemails@vision.com','Scarlett','OhVision','CUST');



--insert into accounts
INSERT INTO ACCOUNT VALUES(1,5,ROUND(3005,2));

INSERT INTO ACCOUNT VALUES(2,6,86734.80);

INSERT INTO ACCOUNT VALUES(3,7,67.99);



--insert into waiting_approval
INSERT INTO WAITING_APPROVAL(U_ID ,START_BAL) VALUES (8,99)















